DEFAULT_DATA_REGISTRY_CONTRACT_ADDRESS = "0xEAd077726dC83ecF385e3763ed4A0A50E8Ac5AA0"
DEFAULT_DATA_VERIFIED_COMPUTING_CONTRACT_ADDRESS = (
    "0x815da22D880E3560bCEcc85b6e4938b30c8202C4"
)
DEFAULT_DATA_ANCHOR_TOKEN_CONTRACT_ADDRESS = (
    "0x2eD344c586303C98FC3c6D5B42C5616ED42f9D9d"
)
DATA_REGISTRY_CONTRACT_ABI = [
    {
        "constant": True,
        "inputs": [],
        "name": "name",
        "outputs": [{"name": "", "type": "string"}],
        "payable": False,
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "version",
        "outputs": [{"name": "", "type": "uint256"}],
        "payable": False,
        "stateMutability": "pure",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "token",
        "outputs": [{"name": "", "type": "address"}],
        "payable": False,
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "verifiedComputing",
        "outputs": [{"name": "", "type": "address"}],
        "payable": False,
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [{"name": "newVerifiedComputing", "type": "address"}],
        "name": "updateVerifiedComputing",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "publicKey",
        "outputs": [{"name": "", "type": "string"}],
        "payable": False,
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [{"name": "newPublicKey", "type": "string"}],
        "name": "updatePublicKey",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [{"name": "url", "type": "string"}],
        "name": "addFile",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [
            {"name": "url", "type": "string"},
            {"name": "ownerAddress", "type": "address"},
            {
                "components": [
                    {"name": "account", "type": "address"},
                    {"name": "key", "type": "string"},
                ],
                "name": "permissions",
                "type": "tuple[]",
            },
        ],
        "name": "addFileWithPermissions",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [
            {"name": "fileId", "type": "uint256"},
            {"name": "account", "type": "address"},
            {"name": "key", "type": "string"},
        ],
        "name": "addPermissionForFile",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "fileId", "type": "uint256"}],
        "name": "getFile",
        "outputs": [
            {
                "components": [
                    {"name": "id", "type": "uint256"},
                    {"name": "url", "type": "string"},
                    {"name": "owner", "type": "address"},
                    {"name": "createdAt", "type": "uint256"},
                ],
                "name": "",
                "type": "tuple",
            }
        ],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "url", "type": "string"}],
        "name": "getFileIdByUrl",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [
            {"name": "fileId", "type": "uint256"},
            {"name": "account", "type": "address"},
        ],
        "name": "getFilePermission",
        "outputs": [{"name": "", "type": "string"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [
            {"name": "fileId", "type": "uint256"},
            {"name": "index", "type": "uint256"},
        ],
        "name": "getFileProof",
        "outputs": [
            {
                "components": [
                    {"name": "timestamp", "type": "uint256"},
                    {"name": "hash", "type": "bytes32"},
                    {"name": "signature", "type": "bytes"},
                ],
                "name": "",
                "type": "tuple",
            }
        ],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "filesCount",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [
            {"internalType": "uint256", "name": "fileId", "type": "uint256"},
            {
                "components": [
                    {"internalType": "bytes", "name": "signature", "type": "bytes"},
                    {
                        "components": [
                            {
                                "internalType": "uint256",
                                "name": "id",
                                "type": "uint256",
                            },
                            {
                                "internalType": "string",
                                "name": "fileUrl",
                                "type": "string",
                            },
                            {
                                "internalType": "string",
                                "name": "proofUrl",
                                "type": "string",
                            },
                        ],
                        "internalType": "struct ProofData",
                        "name": "data",
                        "type": "tuple",
                    },
                ],
                "internalType": "struct Proof",
                "name": "proof",
                "type": "tuple",
            },
        ],
        "name": "addProof",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [
            {"name": "fileId", "type": "uint256"},
            {"name": "proofIndex", "type": "uint256"},
        ],
        "name": "requestReward",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
]
VERIFIED_COMPUTING_CONTRACT_ABI = [
    {
        "type": "enum",
        "name": "NodeStatus",
        "inputs": [
            {"name": "None", "type": "uint8"},
            {"name": "Active", "type": "uint8"},
            {"name": "Removed", "type": "uint8"},
        ],
    },
    {
        "type": "enum",
        "name": "JobStatus",
        "inputs": [
            {"name": "None", "type": "uint8"},
            {"name": "Submitted", "type": "uint8"},
            {"name": "Completed", "type": "uint8"},
            {"name": "Canceled", "type": "uint8"},
        ],
    },
    {
        "type": "struct",
        "name": "Job",
        "components": [
            {"name": "fileId", "type": "uint256"},
            {"name": "bidAmount", "type": "uint256"},
            {"name": "status", "type": "uint8"},
            {"name": "addedTimestamp", "type": "uint256"},
            {"name": "ownerAddress", "type": "address"},
            {"name": "nodeAddress", "type": "address"},
        ],
    },
    {
        "type": "struct",
        "name": "NodeInfo",
        "components": [
            {"name": "nodeAddress", "type": "address"},
            {"name": "url", "type": "string"},
            {"name": "status", "type": "uint8"},
            {"name": "amount", "type": "uint256"},
            {"name": "jobsCount", "type": "uint256"},
            {"name": "publicKey", "type": "string"},
        ],
    },
    {
        "constant": True,
        "inputs": [],
        "name": "version",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "pure",
        "type": "function",
    },
    {
        "inputs": [],
        "name": "pause",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [],
        "name": "unpause",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "nodeFee",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [{"name": "newNodeFee", "type": "uint256"}],
        "name": "updateNodeFee",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "nodeList",
        "outputs": [{"name": "", "type": "address[]"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "index", "type": "uint256"}],
        "name": "nodeListAt",
        "outputs": [
            {
                "components": [
                    {"name": "nodeAddress", "type": "address"},
                    {"name": "url", "type": "string"},
                    {"name": "status", "type": "uint8"},
                    {"name": "amount", "type": "uint256"},
                    {"name": "jobsCount", "type": "uint256"},
                    {"name": "publicKey", "type": "string"},
                ],
                "type": "tuple",
            }
        ],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "nodesCount",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "activeNodesCount",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "activeNodeList",
        "outputs": [{"name": "", "type": "address[]"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "index", "type": "uint256"}],
        "name": "activeNodeListAt",
        "outputs": [
            {
                "components": [
                    {"name": "nodeAddress", "type": "address"},
                    {"name": "url", "type": "string"},
                    {"name": "status", "type": "uint8"},
                    {"name": "amount", "type": "uint256"},
                    {"name": "jobsCount", "type": "uint256"},
                    {"name": "publicKey", "type": "string"},
                ],
                "type": "tuple",
            }
        ],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "nodeAddress", "type": "address"}],
        "name": "getNode",
        "outputs": [
            {
                "components": [
                    {"name": "nodeAddress", "type": "address"},
                    {"name": "url", "type": "string"},
                    {"name": "status", "type": "uint8"},
                    {"name": "amount", "type": "uint256"},
                    {"name": "jobsCount", "type": "uint256"},
                    {"name": "publicKey", "type": "string"},
                ],
                "type": "tuple",
            }
        ],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [
            {"name": "nodeAddress", "type": "address"},
            {"name": "url", "type": "string"},
            {"name": "publicKey", "type": "string"},
        ],
        "name": "addNode",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [{"name": "nodeAddress", "type": "address"}],
        "name": "removeNode",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "nodeAddress", "type": "address"}],
        "name": "isNode",
        "outputs": [{"name": "", "type": "bool"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [{"name": "fileId", "type": "uint256"}],
        "name": "requestProof",
        "outputs": [],
        "stateMutability": "payable",
        "type": "function",
    },
    {
        "inputs": [{"name": "jobId", "type": "uint256"}],
        "name": "completeJob",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [{"name": "jobId", "type": "uint256"}],
        "name": "addProof",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [{"name": "fileId", "type": "uint256"}],
        "name": "submitJob",
        "outputs": [],
        "stateMutability": "payable",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "fileId", "type": "uint256"}],
        "name": "fileJobIds",
        "outputs": [{"name": "", "type": "uint256[]"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [],
        "name": "jobsCount",
        "outputs": [{"name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "constant": True,
        "inputs": [{"name": "jobId", "type": "uint256"}],
        "name": "getJob",
        "outputs": [
            {
                "components": [
                    {"name": "fileId", "type": "uint256"},
                    {"name": "bidAmount", "type": "uint256"},
                    {"name": "status", "type": "uint8"},
                    {"name": "addedTimestamp", "type": "uint256"},
                    {"name": "ownerAddress", "type": "address"},
                    {"name": "nodeAddress", "type": "address"},
                ],
                "type": "tuple",
            }
        ],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [],
        "name": "claim",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
]
DATA_ANCHOR_TOKEN_CONTRACT_ABI = [
    {
        "anonymous": False,
        "inputs": [
            {
                "indexed": True,
                "internalType": "address",
                "name": "to",
                "type": "address",
            },
            {
                "indexed": True,
                "internalType": "uint256",
                "name": "tokenId",
                "type": "uint256",
            },
            {
                "indexed": False,
                "internalType": "string",
                "name": "tokenURI",
                "type": "string",
            },
        ],
        "name": "TokenMinted",
        "type": "event",
    },
    {
        "inputs": [
            {"internalType": "address", "name": "to", "type": "address"},
            {"internalType": "uint256", "name": "amount", "type": "uint256"},
            {"internalType": "string", "name": "tokenURI_", "type": "string"},
            {"internalType": "bool", "name": "verified_", "type": "bool"},
        ],
        "name": "mint",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [{"internalType": "uint256", "name": "tokenId", "type": "uint256"}],
        "name": "uri",
        "outputs": [{"internalType": "string", "name": "", "type": "string"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [{"internalType": "uint256", "name": "tokenId", "type": "uint256"}],
        "name": "verified",
        "outputs": [{"internalType": "bool", "name": "", "type": "bool"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [
            {"internalType": "uint256", "name": "tokenId", "type": "uint256"},
            {"internalType": "bool", "name": "verified_", "type": "bool"},
        ],
        "name": "setTokenVerified",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
    {
        "inputs": [
            {"internalType": "address", "name": "account", "type": "address"},
            {"internalType": "uint256", "name": "id", "type": "uint256"},
        ],
        "name": "balanceOf",
        "outputs": [{"internalType": "uint256", "name": "", "type": "uint256"}],
        "stateMutability": "view",
        "type": "function",
    },
    {
        "inputs": [
            {"internalType": "address", "name": "to", "type": "address"},
            {"internalType": "uint256[]", "name": "ids", "type": "uint256[]"},
            {"internalType": "uint256[]", "name": "amounts", "type": "uint256[]"},
            {"internalType": "string[]", "name": "tokenURIs", "type": "string[]"},
        ],
        "name": "batchMint",
        "outputs": [],
        "stateMutability": "nonpayable",
        "type": "function",
    },
]


class ContractConfig:
    def __init__(
        self,
        data_registry_address: str = None,
        verified_computing_address: str = None,
        data_anchor_token_address: str = None,
    ):
        self.data_registry_address = (
            data_registry_address or DEFAULT_DATA_REGISTRY_CONTRACT_ADDRESS
        )
        self.verified_computing_address = (
            verified_computing_address
            or DEFAULT_DATA_VERIFIED_COMPUTING_CONTRACT_ADDRESS
        )
        self.data_anchor_token_address = (
            data_anchor_token_address or DEFAULT_DATA_ANCHOR_TOKEN_CONTRACT_ADDRESS
        )
